#include <stdio.h>
#include <string.h>

#include "addressbook.h"

void abook_init(ABOOK *abook)
{
    abook->num = 0;
}

void abook_insert(ABOOK *abook, ABOOK_ENTRY *e)
{
    abook->entries[abook->num++] = *e;
}

/** linear seach */
ABOOK_ENTRY abook_search(ABOOK *abook, char *name)
{
    int i;
    for (i=0; i<abook->num; i++) {
        if (strcmp(name, abook->entries[i].name) == 0) 
            return abook->entries[i];
    }
    return abook_empty_entry;
}

void abook_print(ABOOK *abook)
{
    int i;
    printf("Num of entries: %d\n", abook->num);
    for (i=0; i<abook->num; i++) 
        abook_entry_print(&abook->entries[i]);    
    printf("-----------------------------------\n");
}
