#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void print_strings(char **array, int n)
{
   int i;

    for (i=0; i<n; i++) {
        printf("%s, ", array[i]);
    }
    printf("\n");
}

void print_ints(int *array, int n)
{
   int i;

    for (i=0; i<n; i++) {
        printf("%d, ", array[i]);
    }
    printf("\n");
}

int cmp_str(const void *x, const void *y)
{
    const char **p = (const char **)x;
    const char **q = (const char **)y;

    return strcmp(*p, *q);
}

int cmp_int(const void *x, const void *y)
{
    return *((int *)x) > *((int *)y);
}

int main()
{
    char *array[] = {"ABC", "ZGF", "HLK", 
                     "SDF", "PLM", "BSD", 
                     "KKK", "JFL", "VMZ", 
                     "CDA"};

    int arrayint[] = { 9,5,6,7,3,2,0,1,8,4 };
 
    print_strings(array, 10);
    qsort(array, 10, sizeof(char *), cmp_str);
    print_strings(array, 10); 

    print_ints(arrayint, 10);
    qsort(arrayint, 10, sizeof(int), cmp_int);
    print_ints(arrayint, 10);

    char *key = "SDF";
    char **k1 = &key;
    char **f = bsearch(k1, array, 10, sizeof(char *), cmp_str);
    if (f) printf("Found: %s\n", *f);
    else printf("SDF not found\n");

    key = "MNQ";
    k1 = &key;
    f = bsearch(k1, array, 10, sizeof(char *), cmp_str);
    if (f) printf("Found: %s\n", *f);
    else printf("MNQ not found\n");

    return 0;
}
