#ifndef __VECTOR_H__
#define __VECTOR_H__

typedef struct vector_ptr {
    void **array;
    int num_elem;
    int array_size;
} VECTOR_PTR;

void   vptr_init(VECTOR_PTR *v);
void   vptr_push_back(VECTOR_PTR *v, void *elem);
void * vptr_pop_back(VECTOR_PTR *v);
void * vptr_elem_at(VECTOR_PTR *v, int i);
int    vptr_mem_size(VECTOR_PTR *v);
int    vptr_num_elem(VECTOR_PTR *v);

#endif
