#ifndef __LIST_H__
#define __LIST_H__

typedef struct l_node {
    int dato;
    struct l_node *next;
} LNODE;

typedef struct List {
    LNODE *head;
    int nelem;
} LIST;

void list_init(LIST *l);
void list_insert_h(LIST *l, int d);
void list_insert_t(LIST *l, int d);
int list_extract_h(LIST *l);
int list_extract_t(LIST *l);
void list_print(LIST *l);

#endif
